/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel  
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  Copyright (C) 2005 by Freelines CO.,Ltd
 *
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/*
 *	ץå¸⥸塼V850ѡ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 *  ץå¸Ѥѿ
 */
uint8_t intnest;
uint8_t current_intpri;
bool_t lock_flag;
uint16_t saved_imr[IMR_SIZE];
uint16_t disint_table[IMR_SIZE];

/*
 *  ץå¸ν
 */
void
prc_initialize(void)
{
	int_t i;
	
	/* ѿν */
	intnest = 0u;
	current_intpri = 0u;
	lock_flag = true;
	
	for(i = 0 ; i < IMR_SIZE ; i++)
	{
		disint_table[i] = 0x0000;
	}
}

/*
 *  ץå¸νλ
 */
void
prc_terminate(void)
{
	/* ä˹ԤϤʤ */
}

/* ISPRơ֥λ(prc.tfˤ) */
extern const uint16_t imr_table[][IMR_SIZE];

/*
 *	ߤγͥ٥ޥ(ɽ)
 *
 *	饤ؿǤʤΤϡ֥餫Ѥ뤿Ǥ롥
 */
void
set_intpri(uint8_t intpri)
{
	uint_least8_t i;
	
	/* ISPR˽񤭹 */
	for(i = 0 ; i < IMR_SIZE ; i++)
	{
		sil_wrh_mem((void *)(IMR0 + (i * 2)) , 
			imr_table[intpri][i] | disint_table[i]);
	}
}


/*
 *  ׵饤°
 */

struct _int_pol_table
{
	intptr_t pol_setting0;
	intptr_t pol_setting1;
	uint8_t bitpos;
};

struct _int_pol_table const int_pol_table[] = 
{
	/* ֤ˤäư㤦ǽ뤿ᡤޥ */
	INT_POLREG_TABLE
};

void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
	assert(VALID_INTNO_CFGINT(intno));
	assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);
	uint32_t intreg_addr = INTREG_ADDRESS(intno);
	
	/*
	 *  ߤΥޥ
	 *
	 *  ߤդޤޡ٥ȥꥬåȥꥬ䡤
	 *  ͥ٤ԤΤϴʤᡤ°ˤ餺
	 *  öޥ롥
	 */
	(void)x_disable_int(intno);
	
	if(((7u <= (intno)) && ((intno) <= 15u)) || (intno == 1u))
	{	
		/* INTüҤξϳ߸ˡꤹ */
		if((intatr & TA_POSEDGE) != 0U)
		{
			/* Ω夬ꥨå , pol_setting00ˡpol_setting11 */
			sil_wrb_mem((void *)int_pol_table[intno].pol_setting0 , 
					((sil_reb_mem((void *)int_pol_table[intno].pol_setting0))
						& ~(1U << int_pol_table[intno].bitpos)));
			sil_wrb_mem((void *)int_pol_table[intno].pol_setting1 , 
					((sil_reb_mem((void *)int_pol_table[intno].pol_setting1))
						| (1U << int_pol_table[intno].bitpos)));
		}
		else if((intatr & TA_NEGEDGE) != 0U)
		{
			/* Ωꥨå , pol_setting01ˡpol_setting10 */
			sil_wrb_mem((void *)int_pol_table[intno].pol_setting0 , 
					((sil_reb_mem((void *)int_pol_table[intno].pol_setting0))
						| (1U << int_pol_table[intno].bitpos)));
			sil_wrb_mem((void *)int_pol_table[intno].pol_setting1 , 
					((sil_reb_mem((void *)int_pol_table[intno].pol_setting1))
						& ~(1U << int_pol_table[intno].bitpos)));
		}
		else if((intatr & TA_BOTHEDGE) != 0U)
		{
			/* ξå , pol_setting01ˡpol_setting11 */
			sil_wrb_mem((void *)int_pol_table[intno].pol_setting0 , 
					((sil_reb_mem((void *)int_pol_table[intno].pol_setting0))
						| (1U << int_pol_table[intno].bitpos)));
			sil_wrb_mem((void *)int_pol_table[intno].pol_setting1 , 
					((sil_reb_mem((void *)int_pol_table[intno].pol_setting1))
						| (1U << int_pol_table[intno].bitpos)));
		}
	}
	
	/*
	 *  ͥ٤
	 */
	sil_wrb_mem((void *)intreg_addr ,
		((sil_reb_mem((void *)intreg_addr) & ~0x7)
			| (7u - INT_IPM((volatile PRI)intpri))));
	
	/*
	 *  ߤΥޥ
 	 */
	if ((intatr & TA_ENAINT) != 0U) {
		(void)x_enable_int(intno);
	}
}

/*
 * CPU㳰ϥɥν
 * ޥˤasp/kernel/exception.hǥץȥ
 * Ƥ뤿ᡢؿȤʤФʤʤ
 */
void
initialize_exception(void)
{
	/* ⤷ʤ */
}


#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 *  ϿƤʤ㳰ȯȸƤӽФ
 */
void
default_exc_handler(void *p_excinf)
{
    target_exit();
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 *  ̤Ͽγߤȯ˸ƤӽФ
 */
void
default_int_handler(void *p_excinf)
{
    target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */

