/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel  
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  Copyright (C) 2005 by Freelines CO.,Ltd
 *
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/*
 *	ץå¸⥸塼V850ѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåü̿Υ饤ؿ
 */
#include "prc_insn.h"
#include <sil.h>

/*
 *  󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void	*sp;		/* åݥ */
	FP		pc;			/* ץ५ */
} CTXB;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ͥ٥ޥ饤֥
 *
 *	V850ɽ̾ϳͥ٥ޥʤᡤեȥ
 *	ߥ졼󤹤롥ŪˤϡCFG_INT줿׵饤
 *	Ƴͥ٥ޥͤˤбISPR쥸ͤ
 *	ꤹ뤳ȤǹԤ
 */


/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡCAST
 */
#define EXT_IPM(iipm)	 (-CAST(PRI,(iipm)))	   /* ɽɽ */
#define INT_IPM(ipm)	 (CAST(uint32_t, -(ipm)))  /* ɽɽ */

#ifndef TOPPERS_MACRO_ONLY

/* (ǥ)ߤγͥ */
extern uint8_t current_intpri;
/* CPUåե饰 */
extern bool_t lock_flag;
/* CPUåCPUåIMR쥸ͤǼΰ */
extern uint16_t saved_imr[];
/* ػߤƤװǼΰ */
extern uint16_t disint_table[];
/* ߥͥȲ */
extern uint8_t intnest;

/*
 *  ƥȤλ
 */
Inline bool_t
sense_context(void)
{
    return (intnest > 0)? true : false;
}

/*
 *	ߤγͥ٥ޥ(ɽ)μ
 */
Inline uint8_t
get_intpri(void)
{
	return current_intpri;
}

/*
 *	ߤγͥ٥ޥ(ɽ)
 */

extern void set_intpri(uint8_t intpri);

/*
 *	IMR쥸ͤ
 *
 *  restore_imrФ˸ƤФʤФʤʤ
 */
Inline void save_imr(void)
{
	uint_least8_t i;
	
	/* ISPRɤ߽Ф */
	for(i = 0 ; i < IMR_SIZE ; i++)
	{
		saved_imr[i] = sil_reh_mem((void *)(IMR0 + (2 * i)));
	}
}

/*
 *  IMR쥸ͤ
 *
 *  save_imrФ˸ƤФʤФʤʤ
 */
Inline void restore_imr(void)
{
	uint_least8_t i;
	
	/* ISPR˽񤭹 */
	for(i = 0 ; i < IMR_SIZE ; i++)
	{
		sil_wrh_mem((void *)(IMR0 + (2 * i)) , saved_imr[i]);
	}
}

/*
 *  TOPPERSɸ߽ǥμ¸
 */


#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPUå֤Ǥγͥ٥ޥ
 *
 *  TIPM_LOCKϡCPUå֤Ǥγͥ٥ޥʤ
 *  ΤΤ٤Ƥγߤޥͤ롥
 */
#define TIPM_LOCK		TMIN_INTPRI

/*
 *  CPUå֤Ǥγͥ٥ޥɽ
 */
#define INTPRI_LOCK		INT_IPM(TIPM_LOCK)

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 */
#define INTPRI_ENAALL	INT_IPM(TIPM_ENAALL)

#ifndef TOPPERS_MACRO_ONLY


/*
 *  CPUå֤ؤΰܹ
 */
Inline void
x_lock_cpu(void)
{
#if 1
	/* ǳߤäƤϤʤʤᡤߤػߤ롥 */
	disable_int();
	
	save_imr();	/* ߤIMR */
	set_intpri(INTPRI_LOCK);
	lock_flag = true;
	
	/* ߲ */
	enable_int();
#endif
	disable_int();
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUå֤β
 */
Inline void
x_unlock_cpu(void)
{
#if 1
	/* ǳߤäƤϤʤʤᡤߤػߤ롥 */
	disable_int();
	
	restore_imr();	/* IMR */
	set_intpri(current_intpri);
	lock_flag = false;
	
	/* ߲ */
	enable_int();
#endif
	enable_int();
}

#define t_unlock_cpu()    x_unlock_cpu()
#define i_unlock_cpu()    x_unlock_cpu()

/*
 *  CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
    return lock_flag;
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()

/* ena_int/disintͭʳֹϰϤȽ */
#define VALID_INTNO_CFGINT(intno)	(((7u <= (intno)) && ((intno) <= 63u))	\
										|| (intno == 1u))
#define VALID_INTNO_DISINT(intno)	VALID_INTNO_CFGINT((intno))

/*
 *  chg_ipmͭʳͥ٤ϰϤȽ
 */
#define VALID_INTPRI_CHGIPM(intpri) ((intpri) < 8)
/*
 * ʥǥΡ˳ͥ٥ޥ
 */

Inline void
x_set_ipm(PRI intpri)
{
	current_intpri = INT_IPM(intpri);
	set_intpri(current_intpri);
}

#define t_set_ipm(intpri)    x_set_ipm(intpri)
#define i_set_ipm(intpri)    x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 */
Inline PRI
x_get_ipm(void)
{
	return EXT_IPM(current_intpri);
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *  ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void dispatch(void);

/*
 *  ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void);

/*
 *  ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ʥǥΡ˳ͥ
 *  ٥ޥ֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void);

/*
 *  ͥνλθƽФprc_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ롥
 */
extern void    start_r(void);

#define activate_context(p_tcb)												\
{																			\
	(p_tcb)->tskctxb.sp = (uint32_t *)(((uint32_t)(p_tcb)->p_tinib->stk) + 	\
								(p_tcb)->p_tinib->stksz);					\
	(p_tcb)->tskctxb.pc = (void *) start_r;									\
}

/*
 * å¸˴ޤޤɸ㳰ǽνѤʤ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPU㳰ϥɥν
 * ޥˤasp/kernel/exception.hǥץȥ
 * Ƥ뤿ᡢؿȤʤФʤʤ
 */
extern void initialize_exception(void);

/*
 *  ֹ桦ߥϥɥֹ
 *
 *  ߥϥɥֹ(inhno)ȳֹ(intno)ϡ٥ֹѤ롥
 *
 *  ٥ֹ64Ϥޤ뤿ᡤΤޤޤͤͥٴΥơ֥
 *  ǥåѤȡ̵̤ΰ褬ȯ롥Τᡤͥ
 *  Ǥϡ-64ͤѤ롥
 *
 *  ɽ̾ϡiintno,iinhnoȤ롥
 */

/*
 * ߥϥɥֹɽѴ
 */
/* ɽɽ */
#define EXT_INHNO(iintno) (iintno)
/* ɽɽ */
#define INT_INHNO(intno)  (intno)

/*
 * ֹɽѴ
 */
/* ɽɽ */
#define EXT_INTNO(iintno)   (iintno)
/* ɽɽ */
#define INT_INTNO(intno)    (intno)

/*
 *  CPU㳰ϥɥֹ
 *
 */
#define VALID_EXCNO_DEFEXC(excno) (1)

/*
 *  ߥϥɥ
 *
 *	TFե뤿ᡤˤƤ
 */

#define x_define_inh(inhno, int_entry)

/*
 *  ߥϥɥνޥ
 *
 */
#define _INT_ENTRY(inhno, inthdr)    _kernel_##inthdr##_##inhno
#define INT_ENTRY(inhno, inthdr)     _INT_ENTRY(inhno, inthdr)

#define _INTHDR_ENTRY(inhno, inthdr) extern void _kernel_##inthdr##_##inhno(void);
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)  _INTHDR_ENTRY(inhno, inthdr) 

/*
 *  ׵ػߥե饰Υå
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	uint32_t intreg_addr = INTREG_ADDRESS(intno);
	
	if(!VALID_INTNO_DISINT(intno))
	{
		return false;
	}
	
	/* 6bitܤ򥻥å */
	sil_wrb_mem((void *)intreg_addr , 
		sil_reb_mem((void *)intreg_addr) | (0x01U << 6));
	/* ߶ػ߾֥ӥåȤ򥻥å */
	disint_table[(intno / 16u)] |= (1u << (intno % 16u));
	
	return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ׵ػߥե饰β
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */

Inline bool_t
x_enable_int(INTNO intno)
{
	uint32_t intreg_addr = INTREG_ADDRESS(intno);
	
	if(!VALID_INTNO_DISINT(intno))
	{
		return false;
	}
	
	/* 6bitܤ򥯥ꥢ */
	sil_wrb_mem((void *)intreg_addr , 
		sil_reb_mem((void *)intreg_addr) & ~(0x01U << 6));
	/* ߶ػ߾֥ӥåȤ򥯥ꥢ */
	disint_table[(intno / 16u)] &= ~(1u << (intno % 16u));
	
	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)


/*
 *  ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
	uint32_t intreg_addr = INTREG_ADDRESS(intno);
	
	if(!VALID_INTNO_DISINT(intno))
	{
		return ;
	}
	
	/* 7bitܤ򥯥ꥢ */
	sil_wrb_mem((void *)intreg_addr , 
		sil_reb_mem((void *)intreg_addr) & ~(0x01U << 7));
}

#define t_clear_int(intno)		x_clear_int(intno)
#define i_clear_int(intno)		x_clear_int(intno)

/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
	uint32_t intreg_addr = INTREG_ADDRESS(intno);
	
	if(!VALID_INTNO_DISINT(intno))
	{
		return false;
	}
	
	/* 6bitܤΥӥåͤȽꤹ롥*/
	if((sil_reb_mem((void *)intreg_addr) & (0x01U << 6u)) != 0x00)
	{
		return true;
	}
	
	return false;
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)


/*
 *  ׵饤°
 *
 *  V850Ǥϡͥǰͥ٤8ʳǤ뤿ᡤintpri
 *  ȤͿ뤳ȤǤͤ-70ɸǤ롥
 */
extern void x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ߥϥɥɬפIRC
 *
 *  װϼưꥢ뤿Ჿ⤷ʤ
 */
Inline void
i_begin_int(INTNO intno)
{
}

/*
 *  ߥϥɥνиɬפIRC
 *
 * 
 */
Inline void
i_end_int(INTNO intno)
{
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPU㳰ϥɥط
 */

/*
 *  㳰ϥɥ p_excinf ƼФΥޥ
 */
#define P_EXCINF_OFFSET_PC		UINT_C(0)
#define P_EXCINF_OFFSET_SP		UINT_C(4)
#define P_EXCINF_OFFSET_PSW		UINT_C(8)
#define P_EXCINF_OFFSET_ECR		UINT_C(12)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  CPU㳰ϥɥ
 *
 *  ƥץ졼ȥե㳰ϥɥ뤿ᡤ롥
 */
#define x_define_exc(excno, exc_entry)


/*
 *  CPU㳰ϥɥޥ
 */
#define EXC_ENTRY2(excno, exchdr)    _kernel_##exchdr##_##excno
#define EXC_ENTRY(excno, exchdr)     EXC_ENTRY2(excno, exchdr)
#define EXCHDR_ENTRY2(excno, exchdr) extern void _kernel_##exchdr##_##excno(void *sp);
#define EXCHDR_ENTRY(excno, excno_num, exchdr)  EXCHDR_ENTRY2(excno, exchdr)



/*
 *  CPU㳰ȯΥƥȤλ
 *
 *  CPU㳰ȯΥƥȤƥȤλfalse
 *  Ǥʤtrue֤
 */
Inline bool_t
exc_sense_context(void)
{
	return (intnest > 1u)? true : false;
}

/*
 *  CPU㳰ȯ߶ػ߾֤λ
 *
 *  CPU㳰ȯ߶ػ߾֤߶ػ߲֤λfalse
 *  Ǥʤtrue֤
 */
Inline bool_t
exc_sense_id(void *p_excinf)
{
	return (((*((uint32_t *)((uint32_t)p_excinf + P_EXCINF_OFFSET_PSW)))
				& (1u << 5)) != 0u)?
			true : false;
}


/*
 *  CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤʥ
 *  ǥΡ˳ͥ٥ޥ֤ǤtrueǤʤ
 *  false֤CPU㳰ͥγ߽ȯ
 *  ˤfalse֤ˡ
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
	return ((exc_sense_context() == false)
			&& (exc_sense_id(p_excinf) == false)
			&& (get_intpri() == INTPRI_ENAALL))?
			true : false;
}

/*
 *  CPU㳰ȯΥƥȤȳߡCPUå֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤ
 *  trueǤʤfalse֤CPU㳰ͥγ߽
 *  ȯˤfalse֤ˡ
 */
Inline bool_t
exc_sense_unlock(void *p_excinf)
{
	return ((exc_sense_context() == false)
			&& (exc_sense_id(p_excinf) == false)
			&& (x_sense_lock() == false))?
			true : false;
}

/*
 * Trapaʳ㳰ϿƤʤ㳰ȯȸƤӽФ
 */
extern void default_exc_handler(void *p_excinf);

/*
 * ̤Ͽγߤȯ˸ƤӽФ
 */
extern void default_int_handler(void *p_excinf);

/*
 *  ץå¸ν
 */
extern void prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void prc_terminate(void);

/*
 *  atexitνȥǥȥ饯μ¹
 */
Inline void
call_atexit(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

    /*
     *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
     *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
     *  Ǥ롥
     */
    if (fp != 0) {
        (*fp)();
    }
}

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_CONFIG_H */
